<?php

/**
 * Database operations class.
 */
class DB {

    const DB_NAME  = 'sql_injection';
    const PORT     = 5432;            // PostgreSQL default port.
    const DB_HOST  = 'localhost';
    const USERNAME = 'sql_injection_user';
    const PASSWORD = 'sql_injection';

    /**
     * Database connection object.
     */
    private $connection;

    /**
     * Connects to a database with the defined class constants, constructing a connection string like
     * "host='db_host' port='port' dbname='dbname' user='user' password='password'".
     *
     * @return True if the connection was made, false if it was not.
     */
    public function connect() {
        $connectionString = 'host=' . self::DB_HOST . ' port=' . self::PORT . ' dbname=' . self::DB_NAME
            . ' user=' . self::USERNAME . ' password=' . self::PASSWORD;

        $connection = pg_connect($connectionString);

        if ($connection) {
            $connected = true;
            $this->connection = $connection;
        } else {
            $connected = false;
        }

        return $connected;
    }

    /**
     * Closes the opened connection to the database.
     *
     * @return True if the connection was closed succesfully; false if an error happened.
     */
    public function disconnect() {
        $disconnected = pg_close($this->connection);

        return $disconnected;
    }

    /**
     * Authenticates an user with its password, looking if exists a row for the given credentials.
     *
     * @param $username The user to authenticate.
     * @param $password The password to authenticate the user.
     * @return User name if the user was authenticated, false if not.
     */
    public function authenticateUser($username, $password) {
        $sql = "SELECT username
                FROM   Users
                WHERE  username = '$username'
                   AND password = '$password'
                ";

        $result = pg_query($this->connection, $sql);
        $row = pg_fetch_row($result);

        if (!$row) {
            $authenticated = false;
        } else {
            $authenticated = $row[0];
        }

        return $authenticated;
    }
}
