<?php

require_once('DB.php');

/**
 * Checks if the given parameters are set. If one of the specified parameters is not set,
 * die() is called.
 *
 * @param $parameters The parameters to check.
 */
function checkPOSTParametersOrDie($parameters) {
    foreach ($parameters as $parameter) {
        isset($_POST[$parameter]) || die("Please, provide a '$parameter' POST parameter.");
    }
}

// Flow starts here.

checkPOSTParametersOrDie(['username', 'password']);

$db = new DB();
$db->connect() || die('An error occured while connecting to the database.');

$username = $_POST['username'];
$password = $_POST['password'];

$authenticated = $db->authenticateUser($username, $password);

if (!$authenticated) {
    $response = 'Sorry, you could not be authenticated.';
} else {
    $response = "Hello <b>$authenticated</b>, you have been succesfully authenticated.";
}

echo $response;

$db->disconnect();
